<?php

/*
administration page for Logo Links--courtesy machinari
*/

require_once('../../../lib-common.php');

//basic access restricted to plugin's admin or root.
if ((!SEC_inGroup('Root')) || (!SEC_hasRights('logos.edit'))){
    // Someone is trying to illegally access this page
    COM_errorLog("Someone has tried to illegally access the logos admin page.  User id: {$_USER['uid']}, Username: {$_USER['username']}, IP: $REMOTE_ADDR",1);
    $display = COM_siteHeader();
    $display .= COM_startBlock($LANG_LG['access_denied']);
    $display .= $LANG_LG['access_denied_msg1'];
    $display .= COM_endBlock();
    $display .= COM_siteFooter(true);
    echo $display;
    exit;
}


//creates a logos category to which topics may be linked
function lg_createLogo(){
    global $LG_TABLES, $LANG_LG, $_POST, $LG_CONF, $_FILES;

    if ((empty($_POST['localimg'])) && (empty($_FILES['remoteimg']['name']))){
        return $LANG_LG['emptyimg'];
    }

    //check if logo exists by ID
    if (DB_getItem($LG_TABLES['logos'], 'count(*)', "lid='{$_POST['newlid']}'") > 0){
        return $LANG_LG['extant'];
    }

    //validate then insert into database
    $link = logos_addslashes(COM_applyFilter($_POST['link']));
    $ldesc = logos_addslashes(COM_applyFilter($_POST['ldesc']));
    $lid = logos_addslashes(COM_applyFilter($_POST['newlid']));
    $defsort = DB_getItem($LG_TABLES['defaults'], 'sortby');
    if ($defsort === '1'){
        $sortnum = COM_applyFilter($_POST['sortnum'],true);
    }
    $status = COM_applyFilter($_POST['status']);
    //save image
    if (!empty($_FILES['remoteimg']['name'])) {
        //*********************************************************
        //this bit needs a do-over
        if(!logos_save_img($lid)){
            return $LANG_LG['imgerr'];
        } else {
            //this is redundant and just for the db
            $pos = strrpos($_FILES['remoteimg']['name'],'.') + 1;
            $fextension = substr($_FILES['remoteimg']['name'], $pos);
            $filename = 'logo' . '_' . $lid . '.' . $fextension;
        }
    } elseif (!empty($_POST['localimg'])){
        //$pos = strrpos(COM_stripslashes($_POST['localimg']),'.') + 1;
        //$fextension = substr($_POST['localimg'], $pos);
        //$filename = 'logo' . '_' . $lid . '.' . $fextension;
        $filename = logos_addslashes(COM_applyFilter($_POST['localimg']));
        //*********************************************************
    }

    //insert new logo into db
    if (!DB_query("INSERT INTO {$LG_TABLES['logos']} SET lid='$lid', image='$filename', url='$link', ldesc='$ldesc', sortnum='$sortnum', status='$status'")){
        return $LANG_LG['err'];
    } else return $LANG_LG['succ'];
}

//edits existing categories
function lg_editLogo(){
    global $LG_TABLES, $LANG_LG, $_POST, $LG_CONF, $_FILES;

    if ((empty($_POST['localimg'])) && (empty($_FILES['remoteimg']['name']))){
        return $LANG_LG['emptyimg'];
    }

    //validate then update database
    $link = logos_addslashes(COM_applyFilter($_POST['link']));
    $ldesc = logos_addslashes(COM_applyFilter($_POST['ldesc']));
    $lid = logos_addslashes(COM_applyFilter($_POST['newlid']));
    $defsort = DB_getItem($LG_TABLES['defaults'], 'sortby');
    if ($defsort === '1'){
        $sortnum = COM_applyFilter($_POST['sortnum'],true);
    }
    $status = COM_applyFilter($_POST['status']);
    //save image
    if (!empty($_FILES['remoteimg']['name'])) {
        //*********************************************************
        //this bit needs a do-over
        if(!logos_save_img($lid)){
            return $LANG_LG['imgerr'];
        } else {
            //this is redundant and just for the db
            $pos = strrpos($_FILES['remoteimg']['name'],'.') + 1;
            $fextension = substr($_FILES['remoteimg']['name'], $pos);
            $filename = 'logo' . '_' . $lid . '.' . $fextension;
        }
    } elseif (!empty($_POST['localimg'])){
        //$pos = strrpos(COM_stripslashes($_POST['localimg']),'.') + 1;
        //$fextension = substr($_POST['localimg'], $pos);
        //$filename = 'logo' . '_' . $lid . '.' . $fextension;
        $filename = logos_addslashes(COM_applyFilter($_POST['localimg']));
        //*********************************************************
    }

    //udate cat in db
    if (!DB_query("UPDATE {$LG_TABLES['logos']} SET lid='$lid', image='$filename', url='$link', ldesc='$ldesc', sortnum='$sortnum', status='$status' WHERE lid='$lid'")){
        return $LANG_LG['err'];
    } else return $LANG_LG['succ'];
}

//deletes an existing category ???and reassigns topics to default category???
function lg_deleteLogo(){
    global $LG_TABLES, $LANG_LG, $_POST, $_CONF;
    $lid = logos_addslashes(COM_applyfilter($_POST['lid']));
    if (!DB_query("DELETE FROM {$LG_TABLES['logos']} WHERE lid='$lid' LIMIT 1")){
        return $LANG_LG['delerr'];
    } else {
        return $LANG_LG['delsucc'];
    }
}

//display edit page via template files
function logos_edit(){
    global $_TABLES, $_CONF, $LG_CONF, $LANG_LG, $LG_TABLES, $_GET;

    $T = new Template($_CONF['path'] . 'plugins/logos/templates');
    $T->set_file(array ('page' => 'editform.thtml'));

    //get logo settings
    $lid = logos_addslashes(trim(COM_stripslashes($_GET['edit'])));
    if (DB_getItem($LG_TABLES['logos'], 'count(*)', "lid='$lid'") < 1){
        return $LANG_LG['notextant'];
    }
    $a = DB_query("SELECT * FROM {$LG_TABLES['logos']} WHERE lid='$lid'");
    $b = DB_fetchArray($a);

    $T->set_var('site_url', $_CONF['site_url']);
    $T->set_var('action', $_CONF['site_admin_url'] . '/plugins/logos/index.php?edit=' . stripslashes($lid));
    $T->set_var('curimgurl', $_CONF['site_url'] . $LG_CONF['img_url'] . '/' . stripslashes($b['image']));
    $T->set_var('editlegend', sprintf($LANG_LG['editlegend'], COM_stripslashes($lid)));
    $T->set_var('link_label', $LANG_LG['link_label']);
    $T->set_var('curlink', html_entity_decode(stripslashes($b['url'])));
    $T->set_var('httptxt', $LANG_LG['httptxt']);
    $T->set_var('ldesc_label', $LANG_LG['ldesc_label']);
    $T->set_var('curdesc', stripslashes($b['ldesc']));
    $T->set_var('localimg_label', $LANG_LG['localimg_label']);
    $img_pathtxt = sprintf($LANG_LG['img_pathtxt'], $LG_CONF['img_url']);
    $T->set_var('img_pathtxt', $img_pathtxt . '/');
    $T->set_var('curpath', stripslashes($b['image']));
    $T->set_var('remoteimg_label', $LANG_LG['remoteimg_label']);
    $T->set_var('img_types', $LANG_LG['img_types']);
    $T->set_var('lid_label', $LANG_LG['lid_label']);
    $T->set_var('curid', stripslashes($b['lid']));
    $T->set_var('spacetxt', $LANG_LG['spacetxt']);
    $T->set_var('sortnum', $LANG_LG['sortnum']);
    $T->set_var('status_label', $LANG_LG['status_label']);
    $T->set_var('yes', $LANG_LG['yes']);
    $T->set_var('no', $LANG_LG['no']);
    $T->set_var('statuson', '1');
    $T->set_var('statusoff', '0');
    if ($b['status'] == '1'){
        $T->set_var('chkdon', $LANG_LG['checked']);
    } else {
        $T->set_var('chkdoff', $LANG_LG['checked']);
    }
    $T->set_var('statustxt', $LANG_LG['statustxt']);
    $cursort = DB_getItem($LG_TABLES['defaults'], 'sortby');
    if ($cursort === '1'){
        $T->set_var('cursort', stripslashes($b['sortnum']));
    } else {
        $T->set_var('cursort', $LANG_LG['alpha']);
        $T->set_var('disabled', $LANG_LG['disabled']);
    }
    $T->set_var('lid', stripslashes($b['lid']));
    $T->set_var('update', $LANG_LG['update']);
    $T->set_var('reset', $LANG_LG['reset']);
    $T->set_var('delete', $LANG_LG['delete']);
    $T->set_var('deltxt', $LANG_LG['deltxt']);
    $T->set_var('cancel', $LANG_LG['cancel']);

    $T->parse('output','page');
    $retval = $T->finish($T->get_var('output'));
    return $retval;
}

//display admin page via template files
function logos_admin(){
    global $_TABLES, $_CONF, $LG_CONF, $LANG_LG, $LG_TABLES;

    //get defaults
    $def = DB_query("SELECT * FROM {$LG_TABLES['defaults']}");
    $defaults = DB_fetchArray($def);

    $T = new Template($_CONF['path'] . 'plugins/logos/templates');
    $T->set_file(array ('page' => 'admin.thtml', 'newlogo' => 'newlogo.thtml', 'defaults' => 'defaults.thtml'));

    //assign static template vars and defaults
    $T->set_var('menu', logos_menu());
    $T->set_var('site_url', $_CONF['site_url']);
    $T->set_var('action', $_CONF['site_admin_url'] . '/plugins/logos/index.php');
    $T->set_var('newlegend', $LANG_LG['newlegend']);
    $T->set_var('link_label', $LANG_LG['link_label']);
    $T->set_var('newlegend', $LANG_LG['newlegend']);
    $T->set_var('lid_label', $LANG_LG['lid_label']);
    $T->set_var('ldesc_label', $LANG_LG['ldesc_label']);
    $T->set_var('spacetxt', $LANG_LG['spacetxt']);
    $T->set_var('httptxt', $LANG_LG['httptxt']);
    $T->set_var('sortnum', $LANG_LG['sortnum']);
    $T->set_var('status_label', $LANG_LG['status_label']);
    $T->set_var('yes', $LANG_LG['yes']);
    $T->set_var('no', $LANG_LG['no']);
    $T->set_var('checked', $LANG_LG['checked']);
    $T->set_var('statuson', '1');
    $T->set_var('statusoff', '0');
    $T->set_var('statustxt', $LANG_LG['statustxt']);
    if ($defaults['sortby'] == '1'){
        $T->set_var('defsort', '0');
    } else {
        $T->set_var('defsort', $LANG_LG['alpha']);
        $T->set_var('disabled', $LANG_LG['disabled']);
    }
    $T->set_var('displim_label', $LANG_LG['displim_label']);
    $T->set_var('localimg_label', $LANG_LG['localimg_label']);
    $T->set_var('remoteimg_label', $LANG_LG['remoteimg_label']);
    $img_pathtxt = sprintf($LANG_LG['img_pathtxt'], $LG_CONF['img_url']);
    $T->set_var('img_pathtxt', $img_pathtxt . '/');
    $T->set_var('img_types', $LANG_LG['img_types']);
    $T->set_var('create', $LANG_LG['create']);
    $T->set_var('reset', $LANG_LG['reset']);
    $T->set_var('cancel', $LANG_LG['cancel']);
    $T->set_var('update', $LANG_LG['update']);
    $T->set_var('defdisp', $defaults['displim']);
    $T->set_var('displim_label', $LANG_LG['displim_lable']);
    $T->set_var('blk_displim_label', $LANG_LG['blk_displim_label']);
    $T->set_var('blk_displim', $defaults['blk_disp_lim']);
    $T->set_var('defimgurl', $_CONF['site_url'] . $LG_CONF['img_url'] . '/' . 'default_logo.gif');
    $T->set_var('start_newblock', COM_startBlock($LANG_LG['newtitle']));
    $T->set_var('start_defsblock', COM_startBlock($LANG_LG['defstitle']));
    $T->set_var('end_block', COM_endBlock());
    $T->set_var('deflegend', $LANG_LG['deflegend']);
    $T->set_var('maxw_label', $LANG_LG['maxw_label']);
    $T->set_var('maxh_label', $LANG_LG['maxh_label']);
    $T->set_var('curmaxw', $defaults['max_img_width']);
    $T->set_var('curmaxh', $defaults['max_img_height']);
    $T->set_var('pixtxt', $LANG_LG['pixtxt']);
    $T->set_var('maxf_label', $LANG_LG['maxf_label']);
    $T->set_var('curmaxf', $defaults['max_file_size']);
    $T->set_var('sizetxt', $LANG_LG['sizetxt']);
    $T->set_var('displim_label', $LANG_LG['displim_label']);
    $T->set_var('curdisplim', $defaults['displim']);
    $T->set_var('blklim_label', $LANG_LG['blklim_label']);
    $T->set_var('curblklim', $defaults['blk_disp_lim']);
    $T->set_var('sortnum_label', $LANG_LG['sortnum_label']);
    $T->set_var('alphatxt', $LANG_LG['alphatxt']);
    $T->set_var('numtxt', $LANG_LG['numtxt']);
    if ($defaults['sortby'] == '1'){
        $T->set_var('pos', ' selected="selected"');
    } else $T->set_var('alpha', ' selected="selected"');

    $T->parse('newlogo', 'newlogo');
    $T->parse('defaults', 'defaults');

    $T->parse('output','page');
    $retval = $T->finish($T->get_var('output'));
    return $retval;
}

//sets defaults
function lg_setDefaults(){
    global $LG_TABLES, $LANG_LG, $_POST;

    //validate input
    $maxw = COM_applyFilter($_POST['maxw']);
    $maxh = COM_applyFilter($_POST['maxh']);
    $maxf = COM_applyFilter($_POST['maxf']);
    $displim = COM_applyFilter($_POST['displim']);
    $blklim = COM_applyFilter($_POST['blklim']);
    $sortnum = COM_applyFilter($_POST['sortnum']);

    //update database
    if (!DB_query("UPDATE {$LG_TABLES['defaults']} SET max_img_width='$maxw', max_img_height='$maxh', max_file_size='$maxf', displim='$displim', blk_disp_lim='$blklim', sortby='$sortnum'")){
        return $LANG_LG['deferr'];
    } else return $LANG_LG['defsucc'];
}

/*
main function
*/

if ($_POST['submit'] == $LANG_LG['cancel']){
    $display = COM_refresh($_CONF['site_url'] . '/logos/index.php');
}
else {
    $display = COM_siteHeader();
    if ($_POST['submit'] == $LANG_LG['create']){
        $display .= lg_createLogo();
    } elseif ($_POST['submit'] == $LANG_LG['update']){
        $display .= lg_editLogo();
    } elseif ($_POST['submitd'] == $LANG_LG['update']){
        $display .= lg_setDefaults();
    } elseif ($_POST['submit'] == $LANG_LG['delete']) {
        $display .= lg_deleteLogo();
    }
    if (isset($_GET['edit'])){
        if ($_POST['submit'] != $LANG_LG['delete']){
            $display .= COM_startBlock($LANG_LG['edittitle']);
            $display .= logos_edit();
        }
        $display .= logos_menu();
        $display .= COM_endBlock();
    } else {
        $display .= logos_admin();
    }

    $display .= COM_siteFooter();
}

echo $display;

?>