<?php

/*
install page for Logo Links--courtesy machinari
*/


require_once('../../../lib-common.php');
require_once($_CONF['path'] . 'plugins/logos/config.php');
require_once($_CONF['path'] . 'plugins/logos/functions.inc');

//
// install variables
//

$pi_name = 'Logo Links';                     // Plugin name  Must be 15 chars or less
$pi_version = $LG_CONF['version'];           // Plugin Version
$gl_version = '1.3.11';                      // GL Version plugin for
$pi_url = 'http://summitpages.ca';           // Plugin Homepage

//
// Default data
// Insert table name and sql to insert default data for your plugin.
//
$DEFVALUES = array();
$DEFVALUES['defaults'] = "INSERT INTO {$LG_TABLES['defaults']} VALUES (3, 18, 160, 120, 204800, 1)";
$DEFVALUES['randomLogoBlock'] = "INSERT INTO {$_TABLES['blocks']} VALUES ('', 1, 'logos', 'phpblock', 'Random Logos', 'all', 150, '', '', '', 0, 'phpblock_randomLogos', '', 4, 2, 3, 2, 2, 2)";

//
// Security Feature to add
//

$NEWFEATURE = array();
$NEWFEATURE['logos.edit']  ="logos Admin Rights";


// Only let Root users access this page
if (!SEC_inGroup('Root')) {
    // Someone is trying to illegally access this page
    COM_errorLog("Someone has tried to illegally access the logos install/uninstall page.  User id: {$_USER['uid']}, Username: {$_USER['username']}, IP: $REMOTE_ADDR",1);
    $display = COM_siteHeader();
    $display .= COM_startBlock($LANG_LG['access_denied']);
    $display .= $LANG_LG['access_denied_msg'];
    $display .= COM_endBlock();
    $display .= COM_siteFooter(true);
    echo $display;
    exit;
}
 
/**
* Puts the datastructures for this plugin into the Geeklog database
* Note: Corresponding uninstall routine is in functions.inc
* 
* @return   boolean True if successful False otherwise
*
*/
function plugin_install_logos()
{
    global $pi_name, $pi_version, $gl_version, $pi_url, $NEWTABLE, $DEFVALUES, $NEWFEATURE;
    global $_TABLES, $_CONF, $LG_TABLES;

    COM_errorLog("Attempting to install the $pi_name Plugin",1);

    // Create the Plugins Tables
    
    require_once($_CONF['path'] . 'plugins/logos/sql/sql_install.php');
    for ($i = 1; $i <= count($_SQL); $i++) {
        $progress .= "executing " . current($_SQL) . "<br>\n";
        COM_errorLOG("executing " . current($_SQL));
        DB_query(current($_SQL),'1');
        if (DB_error()) {
            COM_errorLog("Error Creating $table table",1);
            plugin_uninstall_logos('DeletePlugin');
            return false;
            exit;
        }
        next($_SQL);
    }
    COM_errorLog("Success - Created $table table",1);
    
    // Insert Default Data
    
    foreach ($DEFVALUES as $table => $sql) {
        COM_errorLog("Inserting default data into $table table",1);
        DB_query($sql,1);
        if (DB_error()) {
            COM_errorLog("Error inserting default data into $table table",1);
            plugin_uninstall_logos();
            return false;
            exit;
        }
        COM_errorLog("Success - inserting data into $table table",1);
    }
    
    // Create the plugin admin security group
    COM_errorLog("Attempting to create $pi_name admin group", 1);
    DB_query("INSERT INTO {$_TABLES['groups']} (grp_name, grp_descr) "
        . "VALUES ('$pi_name Admin', 'Users in this group can administer the $pi_name plugin')",1);
    if (DB_error()) {
        plugin_uninstall_logos();
        return false;
        exit;
    }
    COM_errorLog('...success',1);
    $group_id = DB_insertId();
    
    // Save the grp id for later uninstall
    COM_errorLog('About to save group_id to vars table for use during uninstall',1);
    DB_query("INSERT INTO {$_TABLES['vars']} VALUES ('{$pi_name}_gid', $group_id)",1);
    if (DB_error()) {
        plugin_uninstall_logos();
        return false;
        exit;
    }
    COM_errorLog('...success',1);
    
    // Add plugin Features
    foreach ($NEWFEATURE as $feature => $desc) {
        COM_errorLog("Adding $feature feature",1);
        DB_query("INSERT INTO {$_TABLES['features']} (ft_name, ft_descr) "
            . "VALUES ('$feature','$desc')",1);
        if (DB_error()) {
            COM_errorLog("Failure adding $feature feature",1);
            plugin_uninstall_logos();
            return false;
            exit;
        }
        $feat_id = DB_insertId();
        COM_errorLog("Success",1);
        COM_errorLog("Adding $feature feature to admin group",1);
        DB_query("INSERT INTO {$_TABLES['access']} (acc_ft_id, acc_grp_id) VALUES ($feat_id, $group_id)");
        if (DB_error()) {
            COM_errorLog("Failure adding $feature feature to admin group",1);
            plugin_uninstall_logos();
            return false;
            exit;
        }
        COM_errorLog("Success",1);
    }        

    // OK, now give Root users access to this plugin now! NOTE: Root group should always be 1
    COM_errorLog("Attempting to give all users in Root group access to $pi_name admin group",1);
    DB_query("INSERT INTO {$_TABLES['group_assignments']} VALUES ($group_id, NULL, 1)");
    if (DB_error()) {
        plugin_uninstall_logos();
        return false;
        exit;
    }

    // Register the plugin with Geeklog
    COM_errorLog("Registering $pi_name plugin with Geeklog", 1);
    DB_delete($_TABLES['plugins'],'pi_name',$pi_name);
    DB_query("INSERT INTO {$_TABLES['plugins']} (pi_name, pi_version, pi_gl_version, pi_homepage, pi_enabled) "
        . "VALUES ('$pi_name', '$pi_version', '$gl_version', '$pi_url', 1)");

    if (DB_error()) {
        plugin_uninstall_logos();
        return false;
        exit;
    }

    COM_errorLog("Succesfully installed the $pi_name Plugin!",1);
    return true;
}

/* 
* Main Function
*/

$display = COM_siteHeader();
$T = new Template($_CONF['path'] . 'plugins/logos/templates');
$T->set_file('install', 'install.thtml');
$T->set_var('install_header', $LANG_LG['install_header']);
$T->set_var('img',$_CONF['site_url'] . '/logos/images/logos.gif');
$T->set_var('cgiurl', $_CONF['site_admin_url'] . '/plugins/logos/install.php');
$T->set_var('admin_url', $_CONF['site_admin_url'] . '/plugins/logos/index.php');
$T->set_var('plugin_admin_url', $_CONF['site_admin_url'] . '/plugins.php' );

if ($action == 'install') {
    if (plugin_install_logos()) {
        $install_msg = sprintf($LANG_LG['install_success'],$_CONF['site_admin_url'] .'/plugins/logos/install_doc.html');
        $T->set_var('installmsg1',$LANG_LG['install_success']);
        $T->set_var('editor',$LANG_LG['editor']);
    } else {
        $T->set_var('installmsg1',$LANG_LG['install_failed']);
    }
} else if ($action == "uninstall") {
   plugin_uninstall_logos('installed');
   $T->set_var('installmsg1',$LANG_LG['uninstall_msg']);
}

if (DB_count($_TABLES['plugins'], 'pi_name', 'logos') == 0) {
    $T->set_var('installmsg2', $LANG_LG['uninstalled']);
    $T->set_var('readme', $LANG_LG['readme']);
    $T->set_var('installdoc', $LANG_LG['installdoc']);
    $T->set_var('btnmsg', $LANG_LG['install']);
    $T->set_var('action','install');
} else {
    $T->set_var('installmsg2', $LANG_LG['installed']);
    $T->set_var('btnmsg', $LANG_LG['uninstall']);
    $T->set_var('editor',$LANG_LG['editor']);
    $T->set_var('action','uninstall');
}
$T->parse('output','install');
$display .= $T->finish($T->get_var('output'));
$display .= COM_siteFooter(true);

echo $display;

?>