<?php

/*
functions.inc page for Logo Links--courtesy machinari
*/


/**
* Language file Include
*/
$langfile = $_CONF['path'] . 'plugins/logos/language/' . $_CONF['language'] . '.php';

if (file_exists ($langfile)) 
{
    include_once ($langfile);
}
else 
{
    include_once ($_CONF['path'] . 'plugins/logos/language/english.php');
}

/*
* Include logos config file
*/
require_once ($_CONF['path'] . 'plugins/logos/config.php');

// +---------------------------------------------------------------------------+
// | Geeklog Plugin API Implementations                                        |
// +---------------------------------------------------------------------------+

/**
*
* Geeklog is checking to see if this plugin supports comments, tell it no!
* NOTE: to support comments you must use the same date/time based ID for your
* widget.  In other words, to make primary keys for your plugin you should call
* makesid().  Comments are keyed off of that...it is a limitation on how geeklog
* does comments.
*
* @return   boolean true or false
*
*/
function plugin_commentsupport_logos()
{
    return false;
}

/**
* This will put an option for the plugin in the command and control block on moderation.php
*
* @return   array   Array containing (plugin name, admin url, url of plugin icon)
*
*/
function plugin_cclabel_logos()
{
    global $_CONF, $LANG_LG;

    return array($LANG_LG['plugin_name'],$_CONF['site_admin_url'] . '/plugins/logos/index.php',$_CONF['site_url'] . '/logos/images/logos.gif');
}

/**
* Returns the administrative option for this plugin
*
* @return   array   Array containing (plugin name, plugin admin url, # of items in plugin or '')
*
*/
function plugin_getadminoption_logos()
{
    global $_CONF, $LG_TABLES, $LANG_LG;

    if ((SEC_inGroup('Root')) || (SEC_hasRights('logos.admin'))) {
        $result = DB_query("SELECT COUNT(*) FROM {$LG_TABLES['logos']}");
        list($logos) = DB_fetchArray($result);
        return array($LANG_LG['admin_menu'], $_CONF['site_admin_url'] . '/plugins/logos/index.php', $logos);
    }
}

/**
* Returns the items for this plugin that should appear on the main menu
*
* NOTE: this MUST return the url/value pairs in the following format
* $<arrayname>[<label>] = <url>
*
* @return    array   Associative array of menu items to be added to menu
*
*/
function plugin_getmenuitems_logos()
{
    global $_CONF, $LANG_LG, $LG_TABLES;

    $menulabel = "{$LANG_LG['menulabel']}";                // Put your menu label here
    $menurul = $_CONF['site_url'] . "/logos/index.php";     // Menu url here
    
    $menuitems = array();
    $menuitems["$menulabel"] = $menurul;

    return $menuitems;
}

/**
* Return the current version of code. 
* Used in the Plugin Editor to show the registered version and code version
*/
function plugin_chkVersion_logos()
{
    global $LG_CONF;

    return $LG_CONF['version'];
}

/**
* Removes the datastructures for this plugin from the Geeklog database.
* This routine will get called from the Plugin install program if user select De-Install or if Delete is used in the Plugin Editor.
* The Plugin Installer will also call this routine upon and install error to remove anything it has created.
* The Plugin installer will pass the optional parameter which will then double check that plugin has first been disabled. 
* 
* For this plugin, this routine will also remove the Block definition.
* 
* Returns True if all Plugin related data is removed without error
*
* @param    string   $installCheck     Defult is blank but if set, check if plugin is disabled first
* @return   boolean True if successful false otherwise
*
*/  
function plugin_uninstall_logos($installCheck='')
{
    global $_TABLES, $LG_TABLES, $LANG_LG;

    $pi_name='logos';
    $FEATURES = array ( 'logos.edit');
    $TABLES = array ('defaults','logos');
    
    // Check and see if plugin is still enabled - if so display warning and exit
    if ($installCheck != '' && DB_getItem($_TABLES['plugins'],'pi_enabled', 'pi_name = "' .$pi_name. '"')) {
        COM_errorLog("Plugin is installed and enabled. Disable first if you want to de-install it",1);
        $display = COM_siteHeader();
        $display .= COM_startBlock($LANG_LG['warning']);
        $display .= $LANG_LG['enabled'];
        $display .= COM_endBlock();
        $display .= COM_siteFooter();
        echo $display;
        exit;
    }
        
    // Ok to proceed and delete plugin -- Unregister the plugin with Geeklog
    COM_errorLog('Attempting to unregister the logos plugin from Geeklog',1);
    DB_query("DELETE FROM {$_TABLES['plugins']} WHERE pi_name = '$pi_name'",1);

    // Drop logos tables
    foreach($TABLES as $table) {
        $t = $LG_TABLES["$table"];
        COM_errorLog("Removing Table $t",1);
        DB_query("DROP TABLE $t",1);
    }

    //remove logos blocks created by install
    COM_errorLog("Removing $pi_name blocks",1);
    DB_query("DELETE FROM {$_TABLES['blocks']} WHERE name='logos' LIMIT 1",1);

    // Remove Security for this plugin
    $grp_id = DB_getItem($_TABLES['vars'], 'value', "name = '{$pi_name}_gid'");
    
    COM_errorLog("Removing $pi_name Admin Group", 1);
    DB_query("DELETE FROM {$_TABLES['groups']} WHERE grp_id = $grp_id",1);
    DB_query("DELETE FROM {$_TABLES['vars']} WHERE name = '{$pi_name}_gid'");
    COM_errorLog("Removing root users from admin of $pi_name");
    DB_query("DELETE FROM {$_TABLES['group_assignments']} WHERE ug_main_grp_id = $grp_id",1);
    
    // Remove all the associated features -- access rights
    foreach ($FEATURES as $feature) {
        COM_errorLog("Removing $feature feature and rights to it",1);
        $feat_id = DB_getItem($_TABLES['features'], 'ft_id', "ft_name = '$feature'");
        DB_query("DELETE FROM {$_TABLES['access']} WHERE acc_ft_id = $feat_id",1);
        DB_query("DELETE FROM {$_TABLES['features']} WHERE ft_id = $feat_id",1);
    }
        
    COM_errorLog('...success',1);
    return true;
}

//deletes an existing image that was associated with a category
function logos_delete_img(){
    //not in use atm
    return true;
}

//uploads/saves an image
function logos_save_img($lid){
    global $LG_TABLES, $_POST, $_FILES, $_CONF, $LG_CONF;
    require_once($_CONF['path_system'] . 'classes/upload.class.php');

    //get defaults from db
    $a = DB_query("SELECT max_img_width, max_img_height, max_file_size FROM {$LG_TABLES['defaults']}");
    list($maxwidth, $maxheight, $maxsize) = DB_fetchArray($a);

    //from story.php
    // First, upload the file
    $upload = new upload();
    $upload->setDebug(true);
    $upload->setMaxFileUploads ('1');
    if (!empty($_CONF['image_lib'])) {
        if ($_CONF['image_lib'] == 'imagemagick') {
            // Using imagemagick
            $upload->setMogrifyPath ($_CONF['path_to_mogrify']);
        } elseif ($_CONF['image_lib'] == 'netpbm') {
            // using netPBM
            $upload->setNetPBM ($_CONF['path_to_netpbm']);
        } elseif ($_CONF['image_lib'] == 'gdlib') {
            // using the GD library
            $upload->setGDLib ();
        }
        $upload->setAutomaticResize(true);
        if (isset ($_CONF['debug_image_upload']) && $_CONF['debug_image_upload']) {
            $upload->setLogFile ($_CONF['path'] . 'logs/error.log');
            $upload->setDebug (true);
        }
        $upload->keepOriginalImage (false);
    }
    $upload->setAllowedMimeTypes(array(
            'image/gif' 		=> '.gif',
            'image/pjpeg'		=> '.jpg,.jpeg',
            'image/jpeg'		=> '.jpg,.jpeg',
            'image/png'			=> '.png',
            'image/x-png'		=> '.png'
        ));

    if (!$upload->setPath($_CONF['path_html'] . $LG_CONF['img_path'])) {
        return $upload->printErrors(false);
    }
    // NOTE: if $_CONF['path_to_mogrify'] is set, the call below will
    // force any images bigger than the passed dimensions to be resized.
    // If mogrify is not set, any images larger than these dimensions
    // will get validation errors
    $upload->setMaxDimensions($maxwidth, $maxheight);
    $upload->setMaxFileSize($maxsize); // size in bytes, 1048576 = 1MB
    // Set file permissions on file after it gets uploaded (number is in octal)
    $upload->setPerms('0644');
    //if (!empty($_FILES['remoteimg'])) {
        $pos = strrpos($_FILES['remoteimg']['name'],'.') + 1;
        $fextension = substr($_FILES['remoteimg']['name'], $pos);
        $filename = 'logo' . '_' . $lid . '.' . $fextension;
    //}
    $upload->setFileNames($filename);
    $upload->setDebug(true);
    $upload->uploadFiles();
    if ($upload->areErrors()) {
        //return $upload->printErrors(false);
        return false;
    } else return true;
}

//on page menu
function logos_menu(){
    global $LG_TABLES, $_CONF, $LANG_LG;

    $thisurl = COM_getCurrentURL();
    $indexpage = $_CONF['site_url'] . '/logos/index.php';
    $adminpage = $_CONF['site_admin_url'] . '/plugins/logos/index.php';
    $editpage = 'edit=';

    //begin menu
    //if (eregi($adminpage, $thisurl)){
        $retval = '<div style="text-align: right;"><ul style="list-style: none;">';
        $lststyle = 'style="display: inline; padding: 0 2px;"';
        $lnkstyle = 'style="border: 1px solid #ccc; padding: 2px; border-width: 1px 0 0 1px;"';
    //} else {
    //    $retval = '<div style="float: right; text-align: center;"><ul style="list-style: none;">';
    //    $lststyle = 'style="padding: 2px;"';
    //    $lnkstyle = 'style="display: block; width: 100px; border: 1px solid #ccc; border-width: 1px 0 0 1px;"';
    //}

    //logo index
    if (!eregi($indexpage, $thisurl)){
        $retval .= '<li ' . $lststyle . '><a ' . $lnkstyle . ' href="';
        $retval .= $_CONF['site_url'] . '/logos/index.php">' . $LANG_LG['indexlink'] . '</a></li>';
    }

    //add and admin
    if ((SEC_hasRights('logos.edit')) && (eregi($editpage, $thisurl))){
        $retval .= '<li ' . $lststyle . '><a ' . $lnkstyle . ' href="';
        $retval .= $_CONF['site_admin_url'] . '/plugins/logos/index.php">' . $LANG_LG['adminlink'] . '</a></li>';
    } elseif ((SEC_hasRights('logos.edit')) && (!eregi($adminpage, $thisurl))){
        $retval .= '<li ' . $lststyle . '><a ' . $lnkstyle . ' href="';
        $retval .= $_CONF['site_admin_url'] . '/plugins/logos/index.php">' . $LANG_LG['adminlink'] . '</a></li>';
    }

    //end menu
    $retval .= '</ul></div>';

    return $retval;
}

//chks for magic_quotes and acts accordingly. use only for gpc otherwise use addslashes
function logos_addslashes($str){
    if (!get_magic_quotes_gpc()){//right from the manual :P
        $str = addslashes($str);
    }
    return $str;
}

//custom .thtml for logos block
//template files not included
//$_BLOCK_TEMPLATE['logos'] = 'notitleheader.thtml,notitlefooter.thtml';

//retrieve random logos
function phpblock_randomLogos(){
    global $LANG_LG, $LG_TABLES, $LG_CONF, $_CONF;

    $lim = DB_getItem($LG_TABLES['defaults'], 'blk_disp_lim');
    if (!$logos = DB_query("SELECT DISTINCT lid, image, url, ldesc FROM {$LG_TABLES['logos']} WHERE status='1' ORDER BY rand() LIMIT $lim")){
        COM_errorLog("An error occured while retrieving your quote",1);
        return;
    } else {
        $i = 0;
        $retval = '';
        while ($row = DB_fetchArray($logos)){

            $retval .= '<p align="center">';
            $retval .= '<a href="';
            $retval .= htmlentities(stripslashes($row['url'])) . '">';
            $retval .= '<img src="';
            $retval .= $_CONF['site_url'] . $LG_CONF['img_url'] . '/' . stripslashes($row['image']);
            $retval .= '" alt="';
            $retval .= htmlentities(stripslashes($row['ldesc'])) . '" ';
            list($w, $h, $f, $attr) = getimagesize($_CONF['path_html'] . $LG_CONF['img_path'] . (htmlentities(stripslashes($row['image']))));
            $retval .= $attr . ' border="0" />';
            //$retval .= 'width="200" height="60" border="0"';
            $retval .= '</a></p><br />';
        }
        if (DB_getItem($LG_TABLES['logos'], 'count(*)') > $lim){
            $retval .= '<p align="center"><a href="' . $_CONF['site_url'] . '/logos/index.php' . '">' . $LANG_LG['seeall'] . '</a></p>';
        }
    }

    return $retval;
}

?>